// Code generated by entc, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"

	"github.com/facebook/ent/dialect/sql/sqlgraph"
	"github.com/facebook/ent/schema/field"
	"github.com/kallydev/privacy/ent/jdmodel"
)

// JDModelCreate is the builder for creating a JDModel entity.
type JDModelCreate struct {
	config
	mutation *JDModelMutation
	hooks    []Hook
}

// SetName sets the name field.
func (jmc *JDModelCreate) SetName(s string) *JDModelCreate {
	jmc.mutation.SetName(s)
	return jmc
}

// SetNickname sets the nickname field.
func (jmc *JDModelCreate) SetNickname(s string) *JDModelCreate {
	jmc.mutation.SetNickname(s)
	return jmc
}

// SetPassword sets the password field.
func (jmc *JDModelCreate) SetPassword(s string) *JDModelCreate {
	jmc.mutation.SetPassword(s)
	return jmc
}

// SetEmail sets the email field.
func (jmc *JDModelCreate) SetEmail(s string) *JDModelCreate {
	jmc.mutation.SetEmail(s)
	return jmc
}

// SetIDNumber sets the id_number field.
func (jmc *JDModelCreate) SetIDNumber(s string) *JDModelCreate {
	jmc.mutation.SetIDNumber(s)
	return jmc
}

// SetPhoneNumber sets the phone_number field.
func (jmc *JDModelCreate) SetPhoneNumber(i int64) *JDModelCreate {
	jmc.mutation.SetPhoneNumber(i)
	return jmc
}

// Mutation returns the JDModelMutation object of the builder.
func (jmc *JDModelCreate) Mutation() *JDModelMutation {
	return jmc.mutation
}

// Save creates the JDModel in the database.
func (jmc *JDModelCreate) Save(ctx context.Context) (*JDModel, error) {
	var (
		err  error
		node *JDModel
	)
	if len(jmc.hooks) == 0 {
		if err = jmc.check(); err != nil {
			return nil, err
		}
		node, err = jmc.sqlSave(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*JDModelMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			if err = jmc.check(); err != nil {
				return nil, err
			}
			jmc.mutation = mutation
			node, err = jmc.sqlSave(ctx)
			mutation.done = true
			return node, err
		})
		for i := len(jmc.hooks) - 1; i >= 0; i-- {
			mut = jmc.hooks[i](mut)
		}
		if _, err := mut.Mutate(ctx, jmc.mutation); err != nil {
			return nil, err
		}
	}
	return node, err
}

// SaveX calls Save and panics if Save returns an error.
func (jmc *JDModelCreate) SaveX(ctx context.Context) *JDModel {
	v, err := jmc.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// check runs all checks and user-defined validators on the builder.
func (jmc *JDModelCreate) check() error {
	if _, ok := jmc.mutation.Name(); !ok {
		return &ValidationError{Name: "name", err: errors.New("ent: missing required field \"name\"")}
	}
	if _, ok := jmc.mutation.Nickname(); !ok {
		return &ValidationError{Name: "nickname", err: errors.New("ent: missing required field \"nickname\"")}
	}
	if _, ok := jmc.mutation.Password(); !ok {
		return &ValidationError{Name: "password", err: errors.New("ent: missing required field \"password\"")}
	}
	if _, ok := jmc.mutation.Email(); !ok {
		return &ValidationError{Name: "email", err: errors.New("ent: missing required field \"email\"")}
	}
	if _, ok := jmc.mutation.IDNumber(); !ok {
		return &ValidationError{Name: "id_number", err: errors.New("ent: missing required field \"id_number\"")}
	}
	if _, ok := jmc.mutation.PhoneNumber(); !ok {
		return &ValidationError{Name: "phone_number", err: errors.New("ent: missing required field \"phone_number\"")}
	}
	return nil
}

func (jmc *JDModelCreate) sqlSave(ctx context.Context) (*JDModel, error) {
	_node, _spec := jmc.createSpec()
	if err := sqlgraph.CreateNode(ctx, jmc.driver, _spec); err != nil {
		if cerr, ok := isSQLConstraintError(err); ok {
			err = cerr
		}
		return nil, err
	}
	id := _spec.ID.Value.(int64)
	_node.ID = int(id)
	return _node, nil
}

func (jmc *JDModelCreate) createSpec() (*JDModel, *sqlgraph.CreateSpec) {
	var (
		_node = &JDModel{config: jmc.config}
		_spec = &sqlgraph.CreateSpec{
			Table: jdmodel.Table,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: jdmodel.FieldID,
			},
		}
	)
	if value, ok := jmc.mutation.Name(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: jdmodel.FieldName,
		})
		_node.Name = value
	}
	if value, ok := jmc.mutation.Nickname(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: jdmodel.FieldNickname,
		})
		_node.Nickname = value
	}
	if value, ok := jmc.mutation.Password(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: jdmodel.FieldPassword,
		})
		_node.Password = value
	}
	if value, ok := jmc.mutation.Email(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: jdmodel.FieldEmail,
		})
		_node.Email = value
	}
	if value, ok := jmc.mutation.IDNumber(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeString,
			Value:  value,
			Column: jdmodel.FieldIDNumber,
		})
		_node.IDNumber = value
	}
	if value, ok := jmc.mutation.PhoneNumber(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeInt64,
			Value:  value,
			Column: jdmodel.FieldPhoneNumber,
		})
		_node.PhoneNumber = value
	}
	return _node, _spec
}

// JDModelCreateBulk is the builder for creating a bulk of JDModel entities.
type JDModelCreateBulk struct {
	config
	builders []*JDModelCreate
}

// Save creates the JDModel entities in the database.
func (jmcb *JDModelCreateBulk) Save(ctx context.Context) ([]*JDModel, error) {
	specs := make([]*sqlgraph.CreateSpec, len(jmcb.builders))
	nodes := make([]*JDModel, len(jmcb.builders))
	mutators := make([]Mutator, len(jmcb.builders))
	for i := range jmcb.builders {
		func(i int, root context.Context) {
			builder := jmcb.builders[i]
			var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
				mutation, ok := m.(*JDModelMutation)
				if !ok {
					return nil, fmt.Errorf("unexpected mutation type %T", m)
				}
				if err := builder.check(); err != nil {
					return nil, err
				}
				builder.mutation = mutation
				nodes[i], specs[i] = builder.createSpec()
				var err error
				if i < len(mutators)-1 {
					_, err = mutators[i+1].Mutate(root, jmcb.builders[i+1].mutation)
				} else {
					// Invoke the actual operation on the latest mutation in the chain.
					if err = sqlgraph.BatchCreate(ctx, jmcb.driver, &sqlgraph.BatchCreateSpec{Nodes: specs}); err != nil {
						if cerr, ok := isSQLConstraintError(err); ok {
							err = cerr
						}
					}
				}
				mutation.done = true
				if err != nil {
					return nil, err
				}
				id := specs[i].ID.Value.(int64)
				nodes[i].ID = int(id)
				return nodes[i], nil
			})
			for i := len(builder.hooks) - 1; i >= 0; i-- {
				mut = builder.hooks[i](mut)
			}
			mutators[i] = mut
		}(i, ctx)
	}
	if len(mutators) > 0 {
		if _, err := mutators[0].Mutate(ctx, jmcb.builders[0].mutation); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

// SaveX calls Save and panics if Save returns an error.
func (jmcb *JDModelCreateBulk) SaveX(ctx context.Context) []*JDModel {
	v, err := jmcb.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}
