// Code generated by entc, DO NOT EDIT.

package ent

import (
	"context"
	"errors"
	"fmt"

	"github.com/facebook/ent/dialect/sql/sqlgraph"
	"github.com/facebook/ent/schema/field"
	"github.com/kallydev/privacy/ent/qqmodel"
)

// QQModelCreate is the builder for creating a QQModel entity.
type QQModelCreate struct {
	config
	mutation *QQModelMutation
	hooks    []Hook
}

// SetQqNumber sets the qq_number field.
func (qmc *QQModelCreate) SetQqNumber(i int64) *QQModelCreate {
	qmc.mutation.SetQqNumber(i)
	return qmc
}

// SetPhoneNumber sets the phone_number field.
func (qmc *QQModelCreate) SetPhoneNumber(i int64) *QQModelCreate {
	qmc.mutation.SetPhoneNumber(i)
	return qmc
}

// Mutation returns the QQModelMutation object of the builder.
func (qmc *QQModelCreate) Mutation() *QQModelMutation {
	return qmc.mutation
}

// Save creates the QQModel in the database.
func (qmc *QQModelCreate) Save(ctx context.Context) (*QQModel, error) {
	var (
		err  error
		node *QQModel
	)
	if len(qmc.hooks) == 0 {
		if err = qmc.check(); err != nil {
			return nil, err
		}
		node, err = qmc.sqlSave(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*QQModelMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			if err = qmc.check(); err != nil {
				return nil, err
			}
			qmc.mutation = mutation
			node, err = qmc.sqlSave(ctx)
			mutation.done = true
			return node, err
		})
		for i := len(qmc.hooks) - 1; i >= 0; i-- {
			mut = qmc.hooks[i](mut)
		}
		if _, err := mut.Mutate(ctx, qmc.mutation); err != nil {
			return nil, err
		}
	}
	return node, err
}

// SaveX calls Save and panics if Save returns an error.
func (qmc *QQModelCreate) SaveX(ctx context.Context) *QQModel {
	v, err := qmc.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// check runs all checks and user-defined validators on the builder.
func (qmc *QQModelCreate) check() error {
	if _, ok := qmc.mutation.QqNumber(); !ok {
		return &ValidationError{Name: "qq_number", err: errors.New("ent: missing required field \"qq_number\"")}
	}
	if _, ok := qmc.mutation.PhoneNumber(); !ok {
		return &ValidationError{Name: "phone_number", err: errors.New("ent: missing required field \"phone_number\"")}
	}
	return nil
}

func (qmc *QQModelCreate) sqlSave(ctx context.Context) (*QQModel, error) {
	_node, _spec := qmc.createSpec()
	if err := sqlgraph.CreateNode(ctx, qmc.driver, _spec); err != nil {
		if cerr, ok := isSQLConstraintError(err); ok {
			err = cerr
		}
		return nil, err
	}
	id := _spec.ID.Value.(int64)
	_node.ID = int(id)
	return _node, nil
}

func (qmc *QQModelCreate) createSpec() (*QQModel, *sqlgraph.CreateSpec) {
	var (
		_node = &QQModel{config: qmc.config}
		_spec = &sqlgraph.CreateSpec{
			Table: qqmodel.Table,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: qqmodel.FieldID,
			},
		}
	)
	if value, ok := qmc.mutation.QqNumber(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeInt64,
			Value:  value,
			Column: qqmodel.FieldQqNumber,
		})
		_node.QqNumber = value
	}
	if value, ok := qmc.mutation.PhoneNumber(); ok {
		_spec.Fields = append(_spec.Fields, &sqlgraph.FieldSpec{
			Type:   field.TypeInt64,
			Value:  value,
			Column: qqmodel.FieldPhoneNumber,
		})
		_node.PhoneNumber = value
	}
	return _node, _spec
}

// QQModelCreateBulk is the builder for creating a bulk of QQModel entities.
type QQModelCreateBulk struct {
	config
	builders []*QQModelCreate
}

// Save creates the QQModel entities in the database.
func (qmcb *QQModelCreateBulk) Save(ctx context.Context) ([]*QQModel, error) {
	specs := make([]*sqlgraph.CreateSpec, len(qmcb.builders))
	nodes := make([]*QQModel, len(qmcb.builders))
	mutators := make([]Mutator, len(qmcb.builders))
	for i := range qmcb.builders {
		func(i int, root context.Context) {
			builder := qmcb.builders[i]
			var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
				mutation, ok := m.(*QQModelMutation)
				if !ok {
					return nil, fmt.Errorf("unexpected mutation type %T", m)
				}
				if err := builder.check(); err != nil {
					return nil, err
				}
				builder.mutation = mutation
				nodes[i], specs[i] = builder.createSpec()
				var err error
				if i < len(mutators)-1 {
					_, err = mutators[i+1].Mutate(root, qmcb.builders[i+1].mutation)
				} else {
					// Invoke the actual operation on the latest mutation in the chain.
					if err = sqlgraph.BatchCreate(ctx, qmcb.driver, &sqlgraph.BatchCreateSpec{Nodes: specs}); err != nil {
						if cerr, ok := isSQLConstraintError(err); ok {
							err = cerr
						}
					}
				}
				mutation.done = true
				if err != nil {
					return nil, err
				}
				id := specs[i].ID.Value.(int64)
				nodes[i].ID = int(id)
				return nodes[i], nil
			})
			for i := len(builder.hooks) - 1; i >= 0; i-- {
				mut = builder.hooks[i](mut)
			}
			mutators[i] = mut
		}(i, ctx)
	}
	if len(mutators) > 0 {
		if _, err := mutators[0].Mutate(ctx, qmcb.builders[0].mutation); err != nil {
			return nil, err
		}
	}
	return nodes, nil
}

// SaveX calls Save and panics if Save returns an error.
func (qmcb *QQModelCreateBulk) SaveX(ctx context.Context) []*QQModel {
	v, err := qmcb.Save(ctx)
	if err != nil {
		panic(err)
	}
	return v
}
