// Code generated by entc, DO NOT EDIT.

package ent

import (
	"context"
	"fmt"

	"github.com/facebook/ent/dialect/sql"
	"github.com/facebook/ent/dialect/sql/sqlgraph"
	"github.com/facebook/ent/schema/field"
	"github.com/kallydev/privacy/ent/predicate"
	"github.com/kallydev/privacy/ent/qqmodel"
)

// QQModelUpdate is the builder for updating QQModel entities.
type QQModelUpdate struct {
	config
	hooks    []Hook
	mutation *QQModelMutation
}

// Where adds a new predicate for the builder.
func (qmu *QQModelUpdate) Where(ps ...predicate.QQModel) *QQModelUpdate {
	qmu.mutation.predicates = append(qmu.mutation.predicates, ps...)
	return qmu
}

// SetQqNumber sets the qq_number field.
func (qmu *QQModelUpdate) SetQqNumber(i int64) *QQModelUpdate {
	qmu.mutation.ResetQqNumber()
	qmu.mutation.SetQqNumber(i)
	return qmu
}

// AddQqNumber adds i to qq_number.
func (qmu *QQModelUpdate) AddQqNumber(i int64) *QQModelUpdate {
	qmu.mutation.AddQqNumber(i)
	return qmu
}

// SetPhoneNumber sets the phone_number field.
func (qmu *QQModelUpdate) SetPhoneNumber(i int64) *QQModelUpdate {
	qmu.mutation.ResetPhoneNumber()
	qmu.mutation.SetPhoneNumber(i)
	return qmu
}

// AddPhoneNumber adds i to phone_number.
func (qmu *QQModelUpdate) AddPhoneNumber(i int64) *QQModelUpdate {
	qmu.mutation.AddPhoneNumber(i)
	return qmu
}

// Mutation returns the QQModelMutation object of the builder.
func (qmu *QQModelUpdate) Mutation() *QQModelMutation {
	return qmu.mutation
}

// Save executes the query and returns the number of rows/vertices matched by this operation.
func (qmu *QQModelUpdate) Save(ctx context.Context) (int, error) {
	var (
		err      error
		affected int
	)
	if len(qmu.hooks) == 0 {
		affected, err = qmu.sqlSave(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*QQModelMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			qmu.mutation = mutation
			affected, err = qmu.sqlSave(ctx)
			mutation.done = true
			return affected, err
		})
		for i := len(qmu.hooks) - 1; i >= 0; i-- {
			mut = qmu.hooks[i](mut)
		}
		if _, err := mut.Mutate(ctx, qmu.mutation); err != nil {
			return 0, err
		}
	}
	return affected, err
}

// SaveX is like Save, but panics if an error occurs.
func (qmu *QQModelUpdate) SaveX(ctx context.Context) int {
	affected, err := qmu.Save(ctx)
	if err != nil {
		panic(err)
	}
	return affected
}

// Exec executes the query.
func (qmu *QQModelUpdate) Exec(ctx context.Context) error {
	_, err := qmu.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (qmu *QQModelUpdate) ExecX(ctx context.Context) {
	if err := qmu.Exec(ctx); err != nil {
		panic(err)
	}
}

func (qmu *QQModelUpdate) sqlSave(ctx context.Context) (n int, err error) {
	_spec := &sqlgraph.UpdateSpec{
		Node: &sqlgraph.NodeSpec{
			Table:   qqmodel.Table,
			Columns: qqmodel.Columns,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: qqmodel.FieldID,
			},
		},
	}
	if ps := qmu.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if value, ok := qmu.mutation.QqNumber(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeInt64,
			Value:  value,
			Column: qqmodel.FieldQqNumber,
		})
	}
	if value, ok := qmu.mutation.AddedQqNumber(); ok {
		_spec.Fields.Add = append(_spec.Fields.Add, &sqlgraph.FieldSpec{
			Type:   field.TypeInt64,
			Value:  value,
			Column: qqmodel.FieldQqNumber,
		})
	}
	if value, ok := qmu.mutation.PhoneNumber(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeInt64,
			Value:  value,
			Column: qqmodel.FieldPhoneNumber,
		})
	}
	if value, ok := qmu.mutation.AddedPhoneNumber(); ok {
		_spec.Fields.Add = append(_spec.Fields.Add, &sqlgraph.FieldSpec{
			Type:   field.TypeInt64,
			Value:  value,
			Column: qqmodel.FieldPhoneNumber,
		})
	}
	if n, err = sqlgraph.UpdateNodes(ctx, qmu.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{qqmodel.Label}
		} else if cerr, ok := isSQLConstraintError(err); ok {
			err = cerr
		}
		return 0, err
	}
	return n, nil
}

// QQModelUpdateOne is the builder for updating a single QQModel entity.
type QQModelUpdateOne struct {
	config
	hooks    []Hook
	mutation *QQModelMutation
}

// SetQqNumber sets the qq_number field.
func (qmuo *QQModelUpdateOne) SetQqNumber(i int64) *QQModelUpdateOne {
	qmuo.mutation.ResetQqNumber()
	qmuo.mutation.SetQqNumber(i)
	return qmuo
}

// AddQqNumber adds i to qq_number.
func (qmuo *QQModelUpdateOne) AddQqNumber(i int64) *QQModelUpdateOne {
	qmuo.mutation.AddQqNumber(i)
	return qmuo
}

// SetPhoneNumber sets the phone_number field.
func (qmuo *QQModelUpdateOne) SetPhoneNumber(i int64) *QQModelUpdateOne {
	qmuo.mutation.ResetPhoneNumber()
	qmuo.mutation.SetPhoneNumber(i)
	return qmuo
}

// AddPhoneNumber adds i to phone_number.
func (qmuo *QQModelUpdateOne) AddPhoneNumber(i int64) *QQModelUpdateOne {
	qmuo.mutation.AddPhoneNumber(i)
	return qmuo
}

// Mutation returns the QQModelMutation object of the builder.
func (qmuo *QQModelUpdateOne) Mutation() *QQModelMutation {
	return qmuo.mutation
}

// Save executes the query and returns the updated entity.
func (qmuo *QQModelUpdateOne) Save(ctx context.Context) (*QQModel, error) {
	var (
		err  error
		node *QQModel
	)
	if len(qmuo.hooks) == 0 {
		node, err = qmuo.sqlSave(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*QQModelMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			qmuo.mutation = mutation
			node, err = qmuo.sqlSave(ctx)
			mutation.done = true
			return node, err
		})
		for i := len(qmuo.hooks) - 1; i >= 0; i-- {
			mut = qmuo.hooks[i](mut)
		}
		if _, err := mut.Mutate(ctx, qmuo.mutation); err != nil {
			return nil, err
		}
	}
	return node, err
}

// SaveX is like Save, but panics if an error occurs.
func (qmuo *QQModelUpdateOne) SaveX(ctx context.Context) *QQModel {
	node, err := qmuo.Save(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// Exec executes the query on the entity.
func (qmuo *QQModelUpdateOne) Exec(ctx context.Context) error {
	_, err := qmuo.Save(ctx)
	return err
}

// ExecX is like Exec, but panics if an error occurs.
func (qmuo *QQModelUpdateOne) ExecX(ctx context.Context) {
	if err := qmuo.Exec(ctx); err != nil {
		panic(err)
	}
}

func (qmuo *QQModelUpdateOne) sqlSave(ctx context.Context) (_node *QQModel, err error) {
	_spec := &sqlgraph.UpdateSpec{
		Node: &sqlgraph.NodeSpec{
			Table:   qqmodel.Table,
			Columns: qqmodel.Columns,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: qqmodel.FieldID,
			},
		},
	}
	id, ok := qmuo.mutation.ID()
	if !ok {
		return nil, &ValidationError{Name: "ID", err: fmt.Errorf("missing QQModel.ID for update")}
	}
	_spec.Node.ID.Value = id
	if value, ok := qmuo.mutation.QqNumber(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeInt64,
			Value:  value,
			Column: qqmodel.FieldQqNumber,
		})
	}
	if value, ok := qmuo.mutation.AddedQqNumber(); ok {
		_spec.Fields.Add = append(_spec.Fields.Add, &sqlgraph.FieldSpec{
			Type:   field.TypeInt64,
			Value:  value,
			Column: qqmodel.FieldQqNumber,
		})
	}
	if value, ok := qmuo.mutation.PhoneNumber(); ok {
		_spec.Fields.Set = append(_spec.Fields.Set, &sqlgraph.FieldSpec{
			Type:   field.TypeInt64,
			Value:  value,
			Column: qqmodel.FieldPhoneNumber,
		})
	}
	if value, ok := qmuo.mutation.AddedPhoneNumber(); ok {
		_spec.Fields.Add = append(_spec.Fields.Add, &sqlgraph.FieldSpec{
			Type:   field.TypeInt64,
			Value:  value,
			Column: qqmodel.FieldPhoneNumber,
		})
	}
	_node = &QQModel{config: qmuo.config}
	_spec.Assign = _node.assignValues
	_spec.ScanValues = _node.scanValues()
	if err = sqlgraph.UpdateNode(ctx, qmuo.driver, _spec); err != nil {
		if _, ok := err.(*sqlgraph.NotFoundError); ok {
			err = &NotFoundError{qqmodel.Label}
		} else if cerr, ok := isSQLConstraintError(err); ok {
			err = cerr
		}
		return nil, err
	}
	return _node, nil
}
