// Code generated by entc, DO NOT EDIT.

package ent

import (
	"context"
	"fmt"

	"github.com/facebook/ent/dialect/sql"
	"github.com/facebook/ent/dialect/sql/sqlgraph"
	"github.com/facebook/ent/schema/field"
	"github.com/kallydev/privacy/ent/predicate"
	"github.com/kallydev/privacy/ent/sfmodel"
)

// SFModelDelete is the builder for deleting a SFModel entity.
type SFModelDelete struct {
	config
	hooks    []Hook
	mutation *SFModelMutation
}

// Where adds a new predicate to the delete builder.
func (smd *SFModelDelete) Where(ps ...predicate.SFModel) *SFModelDelete {
	smd.mutation.predicates = append(smd.mutation.predicates, ps...)
	return smd
}

// Exec executes the deletion query and returns how many vertices were deleted.
func (smd *SFModelDelete) Exec(ctx context.Context) (int, error) {
	var (
		err      error
		affected int
	)
	if len(smd.hooks) == 0 {
		affected, err = smd.sqlExec(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*SFModelMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			smd.mutation = mutation
			affected, err = smd.sqlExec(ctx)
			mutation.done = true
			return affected, err
		})
		for i := len(smd.hooks) - 1; i >= 0; i-- {
			mut = smd.hooks[i](mut)
		}
		if _, err := mut.Mutate(ctx, smd.mutation); err != nil {
			return 0, err
		}
	}
	return affected, err
}

// ExecX is like Exec, but panics if an error occurs.
func (smd *SFModelDelete) ExecX(ctx context.Context) int {
	n, err := smd.Exec(ctx)
	if err != nil {
		panic(err)
	}
	return n
}

func (smd *SFModelDelete) sqlExec(ctx context.Context) (int, error) {
	_spec := &sqlgraph.DeleteSpec{
		Node: &sqlgraph.NodeSpec{
			Table: sfmodel.Table,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: sfmodel.FieldID,
			},
		},
	}
	if ps := smd.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return sqlgraph.DeleteNodes(ctx, smd.driver, _spec)
}

// SFModelDeleteOne is the builder for deleting a single SFModel entity.
type SFModelDeleteOne struct {
	smd *SFModelDelete
}

// Exec executes the deletion query.
func (smdo *SFModelDeleteOne) Exec(ctx context.Context) error {
	n, err := smdo.smd.Exec(ctx)
	switch {
	case err != nil:
		return err
	case n == 0:
		return &NotFoundError{sfmodel.Label}
	default:
		return nil
	}
}

// ExecX is like Exec, but panics if an error occurs.
func (smdo *SFModelDeleteOne) ExecX(ctx context.Context) {
	smdo.smd.ExecX(ctx)
}
